#*************************************************************
# Progamm:			korrelations_koeffizient
# Sinn des Programms: 		Berechnung der Korrelationekoeffizienten
#				Zweier Zufallsreihen
#				Zweier Sinusreihen
# Sinn der Einheit  :		Ausgabe	
# Name dieser Datei:		ausgabe.py
# Versionsnummer:		1
# Wird aufgerufen von:		korrelations_koeffizient.py
# Ruft auf:			-
# Nummer im Programmpaket:	5
# von:				5			
# Autor: 			Armin Ulrich
# Erster Lauf: 			15.09.2018
# Letzte Änderung: 		04.06.2020
#*************************************************************

import os


import matplotlib.pyplot as plt


class Ausgabe:

   #Funktion zum Auflösen der Benutzeroberfläche
  def ende(self):
    self.rechner_gui.destroy()

  def schirm_ausgabe(self,m,zufall_1,zufall_2,y_1,y_2):
    print("Schirmausgabe")
    
    for i in range(m):
      print("i=",i,"zufall_1=",zufall_1[i])
    for i in range(m):
      print("i=",i,"zufall_2=",zufall_2[i])
    for i in range(m):
      print("i=",i,"y_1=",y_1[i])
    for i in range(m):
      print("i=",i,"y_2=",y_2[i])
    
    


  def gui_ausgabe(self,korr_koeff_zufall,korr_koeff_klimareihen):
    import tkinter ###
    self.rechner_gui = tkinter.Tk() ###
    self.lb_1 = tkinter.Label(self.rechner_gui, text = "Korrelationskoeffizient der Zufallszahlen:")
    self.lb_1.pack()
    self.lb_2 = tkinter.Label(self.rechner_gui, text = str(round(korr_koeff_zufall,3))) 
    self.lb_2.pack()
    self.lb_3 = tkinter.Label(self.rechner_gui, text = "Korrelationskoeffizient von Temperatur- und Meeresspiegelabweichung:")
    self.lb_3.pack()
    self.lb_4 = tkinter.Label(self.rechner_gui, text = str(round(korr_koeff_klimareihen,3))) 
    self.lb_4.pack()
    self.bende = tkinter.Button(self.rechner_gui, text = "weiter",command = self.ende)
    self.bende.pack()
    self.rechner_gui.mainloop()

  def datei_ausgabe(self,feld_datei,k_k_datei,m,zufall_1,zufall_2,y_1,y_2,zufall_k_k,sinus_k_k):
    print("Dateiausgabe",feld_datei)
    fobj_out = open(feld_datei,"w")
    for i in range(m):
      fobj_out.write(str(i))
      fobj_out.write("\t")
      fobj_out.write(str(zufall_1[i]))
      fobj_out.write("\t")
      fobj_out.write(str(zufall_2[i]))
      fobj_out.write("\t")
      fobj_out.write(str(y_1[i]))
      fobj_out.write("\t")
      fobj_out.write(str(y_2[i]))
      fobj_out.write("\n")
    fobj_out.close()
    fobj_out = open(k_k_datei,"w")
    fobj_out.write("Korrelationskoeffizient der Zufallszahlen: ")
    fobj_out.write("\t")
    fobj_out.write(str(zufall_k_k))
    fobj_out.write("\n")
    fobj_out.write("Korrelationskoeffizient von Temperatur- und Meeresspiegelabweichung: ")
    fobj_out.write("\t")
    fobj_out.write(str(sinus_k_k))
    fobj_out.write("\n")
    fobj_out.write("unter den Bedingungen: ")
    fobj_out.write("\n")
    fobj_out.write("Feldgroesse m= ")
    fobj_out.write("\t")
    fobj_out.write(str(m))
    fobj_out.write("\n")
    fobj_out.close()

  def graphik_ausgabe(self,m,zufall_1,zufall_2,y_1,y_2,graphikdatei_1,graphikdatei_2):
    print("Graphikausgabe")

    plt.plot(zufall_1, 'r.', label='Zufallsreihe 1')
    plt.plot(zufall_2, 'b.', label='Zufallsreihe 2')
      # Achsen-Bereiche manuell festlegen
    
      # Syntax: plt.axis([xmin, xmax, ymin, ymax])
   
    plt.axis([-0.2, m+2, -0.1, 1.3])
    plt.title("Zufallszahlen" )
    plt.xlabel("i [-]")
    plt.ylabel("zufallszahlen [-]")
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm abspeichern
    plt.savefig("zufall.png", format='png')
    # Diagramm anzeigen:
    plt.show()

    plt.plot(y_1, 'r.', label='Temperaturabweichung')
    y_min = 1000.0
    y_max = -1000.0
    for i in range(m):
      if y_min >= y_1[i]:
        y_min = y_1[i]
      if y_max <= y_1[i]:
        y_max = y_1[i]
    y_min-=(y_max-y_min)/5.0
    y_max+=(y_max-y_min)/5.0
    plt.axis([-0.2, m+2, y_min, y_max])
    plt.title("Temperaturabweichung" )
    plt.xlabel("i [-]")
    plt.ylabel("Temperaturabweichung [K]")
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm abspeichern 
    plt.savefig(graphikdatei_1, format='png')
    # Diagramm anzeigen:
    plt.show()

    plt.plot( y_2, 'r.', label='Meeresspiegelabweichung')
    y_min = 1000.0
    y_max = -1000.0
    for i in range(m):
      if y_min >= y_2[i]:
        y_min = y_2[i]
      if y_max <= y_2[i]:
        y_max = y_2[i]
    y_min-=(y_max-y_min)/5.0
    y_max+=(y_max-y_min)/5.0
    plt.axis([-0.2, m+2, y_min, y_max])
    
    plt.title("Meeresspiegelabweichung" )
    plt.xlabel("i [-]")
    plt.ylabel("Meeresspiegelabweichung [mm]")
    plt.legend(loc='upper right', frameon=True)
      # Ein gepunktetes Diagramm-Gitter einblenden:
    plt.grid(True)
    # Diagramm abspeichern 
    plt.savefig(graphikdatei_2, format='png')
    # Diagramm anzeigen:
    plt.show()
